sbit LCD_RS at RC2_bit;
sbit LCD_EN at RC3_bit;
sbit LCD_D4 at RC4_bit;
sbit LCD_D5 at RC5_bit;         // 
sbit LCD_D6 at RC6_bit;
sbit LCD_D7 at RC7_bit;

sbit LCD_RS_Direction at TRISC2_bit;
sbit LCD_EN_Direction at TRISC3_bit;
sbit LCD_D4_Direction at TRISC4_bit;      // 
sbit LCD_D5_Direction at TRISC5_bit;
sbit LCD_D6_Direction at TRISC6_bit;
sbit LCD_D7_Direction at TRISC7_bit;

const char character[]={6,9,9,6,0,0,0,0};
char text[4], txt[8];
unsigned t, t1, ml;
unsigned short sp, ot, ts, grv, grn, dt, tc, td, i, aa, pod;
unsigned short hht, mmt, sst, mmk, hh[6], mm[8];
unsigned short a0, a1, a2, a3, a4, a5, a6, a7, a8, a9;

/*  
hht-  ()
mmt-  ()
sst-  ()
mmk-    ()
sp-   ()
ot-   ()
pod-  ()
grv- ()   ()  ()
grn- ()   ()  ()
tc-   
td-   
ts-  
dt- 
hh[0]-. 1  ()
hh[1]-. 1  ()
hh[2]-. 2  ()
hh[3]-. 2  ()
hh[4]-. 3  ()
hh[5]-. 3  ()
mm[0]-. 1  ()
mm[1]-. 1  ()
mm[2]-. 2  ()
mm[3]-. 2  ()
mm[4]-. 3  ()
mm[5]-. 3  ()
mm[6]-   ()
mm[7]-   ()
*/

void interrupt() {ml++; tmr0=192; intcon=0x20;} // 


void customchar(char pos_row, char pos_char) //   
{
  lcd_cmd(64);
  for (i=0; i<=7; i++) lcd_chr_cp(character[i]);
  lcd_cmd(_lcd_return_home);
  lcd_chr(pos_row, pos_char, 0);
}


void temp() // 
{
  ow_reset(&porta,5);
  ow_write(&porta,5,0x33); // 
  dt=ow_read(&porta,5);

  ow_reset(&porta,5);
  ow_write(&porta,5,0xcc); //  
  ow_write(&porta,5,0x44);
  delay_us(120);
  ow_reset(&porta,5);
  ow_write(&porta,5,0xcc); //  
  ow_write(&porta,5,0xbe);
  t=ow_read(&porta,5); //  
  t=(ow_read(&porta,5)<<8)+t; //  
  tc=t>>4; // 
  t1=t<<0; t1&=0x000f; t1*=625; td=t1/1000; //   ( )
}


void but() // 
{
  if (button(&portb, 3, 1, 1)) a1=1;
  if (a1 && button(&portb, 3, 1, 0)) //  
  {porta.f4=0; pod=0; if (aa==0) {porta.f3=~porta.f3; a1=0;} else
  {if (a5==0) {aa=6;a1=0;a5=1;} else {aa=7;a1=0;a5=0;}}}

  if (button(&portb, 4, 1, 1)) a2=1;
  if (a2 && button(&portb, 4, 1, 0)) //  
  {porta.f4=0; pod=0; if (aa==0) {porta.f2=~porta.f2; a2=0;} else
  {if (a6==0) {aa=8;a2=0;a6=1;} else {aa=9;a2=0;a6=0;}}}

  if (button(&portb, 5, 1, 1)) a3=1;
  if (a3 && button(&portb, 5, 1, 0)) //  
  {porta.f4=0; pod=0; if (aa==0) {porta.f1=~porta.f1; a3=0;} else
  {if (a7==0) {aa=10;a3=0;a7=1;} else {aa=11;a3=0;a7=0;}}}

  if (button(&portb, 6, 1, 1)) a4=1;
  if (a4 && button(&portb, 6, 1, 0)) // 
  {porta.f4=0; pod=0; mmk=0; if (aa==0) {porta.f0=~porta.f0; a4=0;} else
  {if (a8==0) {aa=12;a4=0;a8=1;} else {aa=13;a4=0;a8=0;}}}
}


void tim() //    
{
  bytetostr(hht,text); //   
  if (hht<10) text[1]='0';
  lcd_chr(1,1,text[1]); //  ()
  lcd_chr(1,2,text[2]);
  lcd_chr(1,3,':');

  bytetostr(mmt,text);
  if (mmt<10) text[1]='0';
  lcd_chr(1,4,text[1]);
  lcd_chr(1,5,text[2]); //  ()
  lcd_chr(1,6,':');

  bytetostr(sst,text);
  if (sst<10) text[1]='0';
  lcd_chr(1,7,text[1]); //  ()
  lcd_chr(1,8,text[2]);

  lcd_chr(2,1,' ');
  lcd_chr(2,4,'.');
  CustomChar(2,6); // 
  lcd_chr(2,7,'C');
  lcd_chr(2,8,' ');

  if (dt==0x28) //   
  {
  bytetostr(tc,text);
  lcd_chr(2,2,text[1]); //  ( )
  lcd_chr(2,3,text[2]);

  bytetostr(td,text);
  lcd_chr(2,5,text[2]); //  ( )
  }
  else
  {
  lcd_chr(2,2,'-');
  lcd_chr(2,3,'-'); //   
  lcd_chr(2,5,'-');
  }

  if (button(&portb,1,1,0)) {porta.f4=0; pod=0;} // 
  if (button(&portb,2,1,0)) {porta.f4=0; pod=0;} // 

  if ((button(&portb,2,1,0)) && (button(&portb,1,1,0)))
  {porta.f4=0; pod=0; aa=14; ot--; sp--;} //   
}


void ust() // 
{
  txt[0]=0xab; //
  txt[1]=0xc0; //
  txt[2]=':';
  txt[3]=0xbc; //
  txt[4]=0xbc; //
  txt[5]=':';
  txt[6]='c';
  txt[7]='c';

  for (i=1; i<9; i++) {lcd_chr(1,i,txt[i-1]);} //    

  if (aa==1) // 
  {
  if (button(&portb,1,1,0)) {hht++; porta.f4=0; pod=0;}
  if (hht>23) hht=0;
  bytetostr(hht,text);
  if (hht<10) text[1]='0';
  lcd_chr(2,1,text[1]);
  lcd_chr(2,2,text[2]);
  for (i=3;i<9;i++) {lcd_chr(2,i,' ');}
  }

  if (aa==2) // 
  {
  if (button(&portb,1,1,0)) {mmt++; porta.f4=0; pod=0;}
  if (mmt>59) mmt=0;
  for (i=1;i<4;i++) {lcd_chr(2,i,' ');}
  bytetostr(mmt,text);
  if (mmt<10) text[1]='0';
  lcd_chr(2,4,text[1]);
  lcd_chr(2,5,text[2]);
  for (i=6;i<9;i++) {lcd_chr(2,i,' ');}
  }

  if (aa==3) // 
  {
  if (button(&portb,1,1,0)) {sst=0; porta.f4=0; pod=0;}
  for (i=1;i<7;i++) {lcd_chr(2,i,' ');}
  bytetostr(sst,text);
  if (sst<10) text[1]='0';
  lcd_chr(2,7,text[1]);
  lcd_chr(2,8,text[2]);
  }
}


void termostat() //  
{
  txt[0]='T';
  txt[1]='e';
  txt[2]='p';
  txt[3]='-';
  txt[4]='c';
  txt[5]=0xbf; //
  txt[6]='a';
  txt[7]=0xbf; //

  for (i=1; i<9; i++) {lcd_chr(1,i,txt[i-1]);}

  if (button(&portb,1,1,0)) {ts++; porta.f4=0; pod=0;}
  if (ts>30) ts=15;
  bytetostr(ts,text);
  lcd_chr(2,1,' ');
  lcd_chr(2,2,' ');
  lcd_chr(2,3,text[1]);
  lcd_chr(2,4,text[2]);
  customchar(2,5); // 
  lcd_chr(2,6,'C');
  lcd_chr(2,7,' ');
  lcd_chr(2,8,' ');
  eeprom_write(0x0e,ts); //    
}


void rele() /// 
{
  if (hh[0]!=hh[1] || mm[0]!=mm[1])
  {if (hht==hh[0] && mmt==mm[0]) porta.f3=1; //  
   if (hht==hh[1] && mmt==mm[1]) porta.f3=0;} //  

  if (hh[2]!=hh[3] || mm[2]!=mm[3])
  {if (hht==hh[2] && mmt==mm[2]) porta.f2=1; //  
   if (hht==hh[3] && mmt==mm[3]) porta.f2=0;} //  

  if (hh[4]!=hh[5] || mm[4]!=mm[5])
  {if (hht==hh[4] && mmt==mm[4]) porta.f1=1; //  
   if (hht==hh[5] && mmt==mm[5]) porta.f1=0;} //  


  if (hht>grn-1 && hht<grv) // 
  {
  if (tc<ts) portb.f7=1; if (tc>ts) portb.f7=0; //  ()

  if (mmk==mm[6] && a9==1) {porta.f0=0; a9=0;mmk=0;} // 
  if (mmk==mm[7] && a9==0) {porta.f0=1; a9=1;mmk=0;} // 
  }
  else
  {if (tc<ts-2) portb.f7=1; if (tc>ts-2) portb.f7=0; porta.f0=0;} //  ()
}


void kor() // 
{
  txt[0]='O';
  txt[1]=0xbf; //
  txt[2]='c';
  txt[3]=0xbf; //
  txt[4]='.';
  txt[5]='-';

  for (i=1; i<7; i++) {lcd_chr(1,i,txt[i-1]);}

  if (button(&portb,1,1,0)) {porta.f4=0; pod=0; ot++;}
  if (ot>59) ot=0; //ot- 
  bytetostr(ot,text);
  if (ot<10)
  {lcd_chr(1,7,text[2]); lcd_chr(1,8,' ');}
  else
  {lcd_chr(1,7,text[1]); lcd_chr(1,8,text[2]);}
  eeprom_write(0x0f,ot);

  txt[0]='C';
  txt[1]=0xbe; //
  txt[2]='e';
  txt[3]=0xc1; //
  txt[4]='.';
  txt[5]='-';

  for (i=1; i<7; i++) {lcd_chr(2,i,txt[i-1]);}

  if (button(&portb,2,1,0)) {porta.f4=0; pod=0; sp++;}
  if (sp>59) sp=0; //sp- 
  bytetostr(sp,text);
  if (sp<10)
  {lcd_chr(2,7,text[2]); lcd_chr(2,8,' ');}
  else
  {lcd_chr(2,7,text[1]); lcd_chr(2,8,text[2]);}
  eeprom_write(0x10,sp);

  if (button(&portb,0,1,0)) {porta.f4=0; pod=0; aa=15;} //     
}


void rezh() //   
{
  txt[0]='B';
  txt[1]='e';
  txt[2]='p';
  txt[3]='x';
  txt[4]='.';
  txt[5]='-';

  for (i=1; i<7; i++) {lcd_chr(1,i,txt[i-1]);}

  if (button(&portb,1,1,0)) {porta.f4=0; pod=0; grv++;}
  if (grv>23) grv=20; //grv- ()   () 
  bytetostr(grv,text);
  lcd_chr(1,7,text[1]);
  lcd_chr(1,8,text[2]);
  eeprom_write(0x11,grv);

  txt[0]='H';
  txt[1]=0xb8; //
  txt[2]=0xb6; //
  txt[3]=0xbd; //
  txt[4]='.';
  txt[5]='-';

  for (i=1; i<7; i++) {lcd_chr(2,i,txt[i-1]);}

  if (button(&portb,2,1,0)) {porta.f4=0; pod=0; grn++;}
  if (grn>9) grn=6; //grn- ()   () 
  bytetostr(grn,text);
  lcd_chr(2,7,text[2]);
  lcd_chr(2,8,' ');
  eeprom_write(0x12,grn);
}


void main() // 
{
  Adcon1=6; //  
  porta=0x00; trisa=0xe0;
  portb=0x00; trisb=0x7f;
  portc=0x00; trisc=0x00;
  option_reg=0x04; // 1/32,   
  tmr0=192; intcon=0xA0;

  for (i=0;i<6;i++) {hh[i]=eeprom_read(i); mm[i]=eeprom_read(i+6);} //  
  mm[6]=eeprom_read(0x0c); //      ()
  mm[7]=eeprom_read(0x0d); //      ()
  ts=eeprom_read(0x0e); //    
  ot=eeprom_read(0x0f); //     
  sp=eeprom_read(0x10); //     
  grv=eeprom_read(0x11); //    ()   () 
  grn=eeprom_read(0x12); //    ()   () 

  sst=mmt=hht=aa=pod=mmk=0; ml=0; a0=a1=a2=a3=a4=a5=a6=a7=a8=0; a9=1;

  lcd_init(); // 
  lcd_cmd(_lcd_cursor_off); // 

  do
  {
  if (ml==993)
  {
  ml=0; sst++; pod++;

  if (pod>9) {porta.f4=1; aa=0;} if (pod>15) pod=10; //./. 

  if ((hht==0 && mmt==0) || (hht==6 && mmt==0) || (hht==12 && mmt==0) || (hht==18 && mmt==0))
  {if (sst>59-ot+sp) {mmt++; sst=0; mmk++;}}
  else
  {if (sst>59) {mmt++; sst=0; mmk++;}} //sst-, mmk-   
  if (mmt>59) {hht++; mmt=0;} //mmt-
  if (hht>23) hht=0; //hht-

  temp(); //   

  if (button(&portb, 0, 1, 1)) a0=1;
  if (a0 && button(&portb, 0, 1, 0)) {porta.f4=0; pod=0; if (aa<5) {aa++; a0=0;}}

  if (aa==0) tim(); //   

  if (aa>0 && aa<4) ust(); // 

  if (aa==4) termostat(); //  

  if (aa==5) aa=0; //     


  if (aa>5 && aa<12) // 
  {
  txt[0]='P';
  txt[1]='e';
  txt[2]=0xbb; //
  txt[3]='e';
  txt[4]='-';
  txt[6]=' ';

  if (aa==6) {txt[5]='1'; txt[7]=0xd9;}

  if (aa==7) {txt[5]='1'; txt[7]=0xda;}

  if (aa==8) {txt[5]='2'; txt[7]=0xd9;}

  if (aa==9) {txt[5]='2'; txt[7]=0xda;}

  if (aa==10) {txt[5]='3'; txt[7]=0xd9;}

  if (aa==11) {txt[5]='3'; txt[7]=0xda;}

  for (i=1; i<9; i++) {lcd_chr(1,i,txt[i-1]);}

  if (button(&portb,1,1,0)) {hh[aa-6]++; porta.f4=0; pod=0;}
  if (button(&portb,2,1,0)) {mm[aa-6]++; porta.f4=0; pod=0;}
  if (hh[aa-6]>23) hh[aa-6]=0;  if (mm[aa-6]>59) mm[aa-6]=0;

  bytetostr(hh[aa-6],text);
  if (hh[aa-6]<10) text[1]='0';
  lcd_chr(2,1,text[1]);
  lcd_chr(2,2,text[2]);
  bytetostr(mm[aa-6],text);
  if (mm[aa-6]<10) text[1]='0';
  lcd_chr(2,3,':');
  lcd_chr(2,4,text[1]);
  lcd_chr(2,5,text[2]);
  lcd_chr(2,6,':');
  lcd_chr(2,7,'0');
  lcd_chr(2,8,'0');
  eeprom_write(aa-6,hh[aa-6]);  //    
  eeprom_write(aa,mm[aa-6]);
  }


  if (aa==12 || aa==13) // 
  {
  txt[0]='B';
  txt[1]='o';
  txt[2]=0xb7; //
  txt[3]=0xe3; //
  txt[4]='y';
  txt[5]='x';
  txt[6]=' ';

  if (aa==12) txt[7]=0xd9;  if (aa==13) txt[7]=0xda;

  for (i=1; i<9; i++) {lcd_chr(1,i,txt[i-1]);}

  lcd_chr(2,4,' ');
  lcd_chr(2,5,0xbc); //
  lcd_chr(2,6,0xb8); //
  lcd_chr(2,7,0xbd); //
  lcd_chr(2,8,'.');

  if (button(&portb,1,1,0)) {porta.f4=0; pod=0; mm[aa-6]=mm[aa-6]+10;}
  if (button(&portb,2,1,0)) {porta.f4=0; pod=0; mm[aa-6]=mm[aa-6]+1;}
  if (mm[aa-6]>240) mm[aa-6]=0;
  bytetostr(mm[aa-6],text);
  if (mm[aa-6]<10) {lcd_chr(2,3,text[2]); lcd_chr(2,2,' '); lcd_chr(2,1,' ');}

  if (mm[aa-6]>9 && mm[aa-6]<100) {lcd_chr(2,2,text[1]); lcd_chr(2,3,text[2]); lcd_chr(2,1,' ');}

  if (mm[aa-6]>99) {lcd_chr(2,1,text[0]); lcd_chr(2,2,text[1]); lcd_chr(2,3,text[2]);}
  eeprom_write(aa,mm[aa-6]);
  }

  if (aa==14) kor(); //   

  if (aa==15) rezh(); //     

  /*   EEPROM
  0x00-   ()
  001-   ()
  002-   ()
  003-   ()
  004-   ()
  005-   ()
  0x06-   ()
  007-   ()
  008-   ()
  009-   ()
  00a-   ()
  00b-   ()
  00c-  
  00d-  
  0x0e- 
  0x0f-  
  0x10-  
  0x11- ()   () 
  0x12- ()   () 
  */

  rele(); /// 

  but(); // 
  }
  } while(1);
}
